package service

import (
	"go/ast"
)

var (
	isPointerType = false
)

func handleTypeSpec(spec ast.Spec) (code string) {
	s := spec.(*ast.TypeSpec)
	handleClass(s)
	return
}

func handleStructType(s *ast.StructType) (code string) {
	return handleFieldList(s.Fields)
}

func handleFieldList(l *ast.FieldList) string {
	code := ""
	for _, f := range l.List {
		code += handleField(f)
	}
	return code
}

func handleField(f *ast.Field) string {
	code := ""
	code += "  "
	code += handleIdentExpr(f.Type)
	code += " "
	nado_zapyatuyu := false
	for _, n := range f.Names {
		if nado_zapyatuyu {
			code += ","
		}
		code += handleIdentExpr(n)
		nado_zapyatuyu = true
	}
	code += ";\n"
	return code
}
